Your search did not match any results.

JavaScript/jQuery Data Grid - SignalR Service

This example demonstrates real-time data update in a JavaScript DataGrid bound to a SignalR service. Access to the service is configured in a CustomStore.

The CustomStore fetches the remote dataset at launch and keeps its local copy. Whenever the remote dataset changes, the server calls a client-side function that updates the local copy of the dataset (updateStockPrices in this demo). This function uses the store's push(changes) method.

For server-side configuration, refer to the ASP.NET MVC version of this demo.

Backend API
$(() => { $.type = $.type || function getType(obj) { if (obj == null) { return `${obj}`; } return typeof obj; }; const connection = new signalR.HubConnectionBuilder() .withUrl('https://js.devexpress.com/Demos/NetCore/liveUpdateSignalRHub', { skipNegotiation: true, transport: signalR.HttpTransportType.WebSockets, }) .configureLogging(signalR.LogLevel.Information) .build(); const store = new DevExpress.data.CustomStore({ load() { return connection.invoke('getAllStocks'); }, key: 'symbol', }); connection.on('updateStockPrice', (data) => { store.push([{ type: 'update', key: data.symbol, data }]); }); connection.start().then(() => { $('#gridContainer').dxDataGrid({ dataSource: store, showBorders: true, repaintChangesOnly: true, highlightChanges: true, columns: [{ dataField: 'lastUpdate', dataType: 'date', width: 115, format: 'longTime', }, { dataField: 'symbol', }, { dataField: 'price', dataType: 'number', format: '#0.####', cellTemplate(container, options) { const wrapper = $('<div>') .addClass((options.data.change > 0) ? 'inc' : 'dec') .text(options.text); wrapper.appendTo(container); }, }, { dataField: 'change', dataType: 'number', width: 140, format: '#0.####', cellTemplate(container, options) { const fieldData = options.data; const wrapper = $('<div>') .addClass(fieldData.change > 0 ? 'inc' : 'dec'); $('<span>') .addClass('current-value') .text(options.text) .appendTo(wrapper); $('<span>') .addClass('arrow') .appendTo(wrapper); $('<span>') .addClass('diff') .text(`${fieldData.percentChange.toFixed(2)}%`) .appendTo(wrapper); wrapper.appendTo(container); }, }, { dataField: 'dayOpen', dataType: 'number', format: '#0.####', }, { dataField: 'dayMin', dataType: 'number', format: '#0.####', }, { dataField: 'dayMax', dataType: 'number', format: '#0.####', }], }); }); });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <script src="js/signalr.js"></script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.8/css/dx.light.css" /> <script src="js/dx.all.js?v=25.2.8"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="gridContainer"></div> </div> </body> </html>
#gridContainer span.current-value { display: inline-block; margin-right: 5px; } #gridContainer span.diff { width: 50px; display: inline-block; } #gridContainer .inc { color: #2ab71b; } #gridContainer .dec { color: #f00; } #gridContainer .inc .arrow, #gridContainer .dec .arrow { display: inline-block; height: 10px; width: 10px; background-repeat: no-repeat; background-size: 10px 10px; } #gridContainer .inc .arrow { background-image: url('data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAABQAAAAUCAYAAACNiR0NAAAABGdBTUEAAK/INwWK6QAAABl0RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAADKSURBVHjaYtTaLs1ABEiG0nPRJa56PEHhsxBhmCUQT4OyrwHxcXyKmQgYJgHE64CYDYrXQcXIMhCbAcgWkGzgNKh38QUB0QamIUUErkhKI9ZAGyCeTERkTYaqxWsgKA2txhdG6GGsvUNGGpeBRMUiGhCFGsqGzUBQQJsxkA5AemaiG5hDIBIIgQSgK0FmMDACs549kN5FZLjhA7+A2A2U9YSAOBeLAk4gnoBDczoOcSFGPIUDPxB/wCHHiKtwYGKgMhg1cBAaCBBgAJTUIL3ToPZfAAAAAElFTkSuQmCC'); } #gridContainer .dec .arrow { background-image: url('data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAABQAAAAUCAYAAACNiR0NAAAABGdBTUEAAK/INwWK6QAAABl0RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAADJSURBVHjaYvzPgBfgkhYA4o8QFahKmBioDEYNHIQGsgBxIBCLkqgvAYi/g1mMjMjir0EJzR6If/6HpChKMMgMe3DKBeIcKhiY8x/MYoDj+RQYNgdkGLqBbEB8kgzDToL1YjEQhKWB+BUJhj0H64Eahs1AELYhMpJ+gtUiGYbLQBBOI8LANLBaIg1kAAc0vkiAqSPBQFAkHcNi2DGoHMkGgrAENOCRI0ECRQ2JBoKwJTQCfkLZDPgMZPxPXN5NhtJzMSsJVBMAAgwAyWSY2svfmrwAAAAASUVORK5CYII='); }
using System.Collections.Generic; using DevExtreme.MVC.Demos.Models.SignalR; using Microsoft.AspNet.SignalR; namespace DevExtreme.MVC.Demos.Hubs { public class LiveUpdateSignalRHub : Hub { private readonly StockTicker _stockTicker; public LiveUpdateSignalRHub() { _stockTicker = StockTicker.Instance; } public IEnumerable<Stock> GetAllStocks() { return _stockTicker.GetAllStocks(); } } }
using System; using System.Collections.Generic; using System.Threading; using DevExtreme.MVC.Demos.Hubs; using Microsoft.AspNet.SignalR; using Microsoft.AspNet.SignalR.Hubs; using DevExpress.Data.Utils; namespace DevExtreme.MVC.Demos.Models.SignalR { public class StockTicker { public readonly static StockTicker Instance = new StockTicker(GlobalHost.ConnectionManager.GetHubContext<LiveUpdateSignalRHub>().Clients); private readonly IEnumerable<Stock> _stocks; private IHubConnectionContext<dynamic> Clients { get; set; } private readonly TimeSpan _updateInterval = TimeSpan.FromMilliseconds(500); private readonly NonCryptographicRandom _updateOrNotRandom = NonCryptographicRandom.System; private readonly Timer _timer; private readonly object _updateStockPricesLock = new object(); static readonly NonCryptographicRandom random = NonCryptographicRandom.System; private StockTicker(IHubConnectionContext<dynamic> clients) { Clients = clients; _stocks = GenerateStocks(); _timer = new Timer(UpdateStockPrices, null, _updateInterval, _updateInterval); } public IEnumerable<Stock> GetAllStocks() { return _stocks; } static IEnumerable<Stock> GenerateStocks() { return new[] { new Stock(37.95M) { Symbol = "MSFT", DayOpen=36.5M, LastUpdate = DateTime.Now }, new Stock(24.85M) { Symbol = "INTC", DayOpen=24.9M, LastUpdate = DateTime.Now }, new Stock(22.99M){ Symbol = "CSCO", DayOpen=22.7M, LastUpdate = DateTime.Now }, new Stock(30.71M){ Symbol = "SIRI", DayOpen=30.7M, LastUpdate = DateTime.Now }, new Stock(58.73M){ Symbol = "AAPL", DayOpen=54.9M, LastUpdate = DateTime.Now }, new Stock(110M){ Symbol = "HOKU", DayOpen=121.2M, LastUpdate = DateTime.Now }, new Stock(38.11M){ Symbol = "ORCL", DayOpen=37.9M, LastUpdate = DateTime.Now }, new Stock(17.61M) { Symbol = "AMAT", DayOpen=17.5M, LastUpdate = DateTime.Now }, new Stock(40.80M){ Symbol = "YHOO", DayOpen=39.9M, LastUpdate = DateTime.Now }, new Stock(31.85M){ Symbol = "LVLT", DayOpen=32.9M, LastUpdate = DateTime.Now }, new Stock(20.63M){ Symbol = "DELL", DayOpen=17.9M, LastUpdate = DateTime.Now }, new Stock(63.70M) { Symbol = "GOOG", DayOpen=55.9M, LastUpdate = DateTime.Now } }; } private void UpdateStockPrices(object state) { lock(_updateStockPricesLock) { foreach(var stock in _stocks) { if(TryUpdateStockPrice(stock)) { BroadcastStockPrice(stock); } } } } private bool TryUpdateStockPrice(Stock stock) { var r = _updateOrNotRandom.NextDouble(); if(r > .1) { return false; } stock.Update(); return true; } private void BroadcastStockPrice(Stock stock) { Clients.All.updateStockPrice(stock); } } }
using System; using DevExpress.Data.Utils; namespace DevExtreme.MVC.Demos.Models.SignalR { public class Stock { readonly decimal _initPrice; public Stock(decimal price) { Price = price; DayMax = price; DayMin = price; _initPrice = Price; } public string Symbol { get; set; } public decimal Price { get; set; } public decimal DayMax { get; set; } public decimal DayMin { get; set; } public decimal DayOpen { get; set; } public DateTime LastUpdate { get; set; } public decimal Change { get { return Price - DayOpen; } } public double PercentChange { get { return (double)Math.Round(Change * 100 / DayOpen, 2); } } public void Update() { var isNewDay = LastUpdate.Day != DateTime.Now.Day; var change = GenerateChange(); var newPrice = _initPrice + _initPrice * change; Price = newPrice; LastUpdate = DateTime.Now; if(Price > DayMax || isNewDay) DayMax = Price; if(Price < DayMin || isNewDay) DayMin = Price; } static NonCryptographicRandom random = NonCryptographicRandom.System; decimal GenerateChange() { return (decimal)random.Next(-200, 200) / 10000; } } }

For more information about integration with push services, refer to the following help topic: Integration with Push Services.

Data used in this demo is for demonstration purposes only.

Backend API
<div ng-if="connectionStarted">
<dx-data-grid
id="gridContainer"
[dataSource]="dataSource"
[showBorders]="true"
[repaintChangesOnly]="true"
[highlightChanges]="true"
>
<dxi-data-grid-column
dataField="lastUpdate"
dataType="date"
[width]="115"
format="longTime"
>
</dxi-data-grid-column>
<dxi-data-grid-column dataField="symbol"> </dxi-data-grid-column>
<dxi-data-grid-column
dataField="price"
dataType="number"
format="#0.####"
cellTemplate="priceCellTemplate"
>
</dxi-data-grid-column>
<dxi-data-grid-column
dataField="change"
dataType="number"
[width]="140"
format="#0.####"
cellTemplate="changeCellTemplate"
>
</dxi-data-grid-column>
<dxi-data-grid-column
dataField="dayOpen"
dataType="number"
format="#0.####"
>
</dxi-data-grid-column>
<dxi-data-grid-column dataField="dayMin" dataType="number" format="#0.####">
</dxi-data-grid-column>
<dxi-data-grid-column dataField="dayMax" dataType="number" format="#0.####">
</dxi-data-grid-column>
<div
*dxTemplate="let cell of 'priceCellTemplate'"
[class.inc]="cell.data.change > 0"
[class.dec]="cell.data.change < 0"
>
<span>{{ cell.text }}</span>
</div>
<div
*dxTemplate="let cell of 'changeCellTemplate'"
[class.inc]="cell.data.change > 0"
[class.dec]="cell.data.change < 0"
>
<span class="current-value">{{ cell.text }}</span>
<span class="arrow"></span>
<span class="diff">{{ cell.data.percentChange.toFixed(2) }}%</span>
</div>
</dx-data-grid>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { HubConnectionBuilder, HttpTransportType } from '@aspnet/signalr';
import { DxDataGridModule } from 'devextreme-angular';
import { CustomStore } from 'devextreme-angular/common/data';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
imports: [
DxDataGridModule,
],
})
export class AppComponent {
dataSource: CustomStore;
connectionStarted: boolean;
constructor() {
this.connectionStarted = false;
const hubConnection = new HubConnectionBuilder()
.withUrl('https://js.devexpress.com/Demos/NetCore/liveUpdateSignalRHub', {
skipNegotiation: true,
transport: HttpTransportType.WebSockets,
})
.build();
const store = new CustomStore({
load: () => hubConnection.invoke('getAllStocks'),
key: 'symbol',
});
hubConnection
.start()
.then(() => {
hubConnection.on('updateStockPrice', (data: Record<string, unknown>) => {
store.push([{ type: 'update', key: data.symbol, data }]);
});
this.dataSource = store;
this.connectionStarted = true;
});
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep #gridContainer span.current-value {
display: inline-block;
margin-right: 5px;
}
::ng-deep #gridContainer span.diff {
width: 50px;
display: inline-block;
}
::ng-deep #gridContainer .inc {
color: #2ab71b;
}
::ng-deep #gridContainer .dec {
color: #f00;
}
::ng-deep #gridContainer .inc .arrow,
::ng-deep #gridContainer .dec .arrow {
display: inline-block;
height: 10px;
width: 10px;
background-repeat: no-repeat;
background-size: 10px 10px;
}
::ng-deep #gridContainer .inc .arrow {
background-image: url('data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAABQAAAAUCAYAAACNiR0NAAAABGdBTUEAAK/INwWK6QAAABl0RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAADKSURBVHjaYtTaLs1ABEiG0nPRJa56PEHhsxBhmCUQT4OyrwHxcXyKmQgYJgHE64CYDYrXQcXIMhCbAcgWkGzgNKh38QUB0QamIUUErkhKI9ZAGyCeTERkTYaqxWsgKA2txhdG6GGsvUNGGpeBRMUiGhCFGsqGzUBQQJsxkA5AemaiG5hDIBIIgQSgK0FmMDACs549kN5FZLjhA7+A2A2U9YSAOBeLAk4gnoBDczoOcSFGPIUDPxB/wCHHiKtwYGKgMhg1cBAaCBBgAJTUIL3ToPZfAAAAAElFTkSuQmCC');
}
::ng-deep #gridContainer .dec .arrow {
background-image: url('data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAABQAAAAUCAYAAACNiR0NAAAABGdBTUEAAK/INwWK6QAAABl0RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAADJSURBVHjaYvzPgBfgkhYA4o8QFahKmBioDEYNHIQGsgBxIBCLkqgvAYi/g1mMjMjir0EJzR6If/6HpChKMMgMe3DKBeIcKhiY8x/MYoDj+RQYNgdkGLqBbEB8kgzDToL1YjEQhKWB+BUJhj0H64Eahs1AELYhMpJ+gtUiGYbLQBBOI8LANLBaIg1kAAc0vkiAqSPBQFAkHcNi2DGoHMkGgrAENOCRI0ECRQ2JBoKwJTQCfkLZDPgMZPxPXN5NhtJzMSsJVBMAAgwAyWSY2svfmrwAAAAASUVORK5CYII=');
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.8/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.25',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.67',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'@aspnet/signalr': 'npm:@aspnet/signalr@1.0.27/dist/cjs/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.25/package.json',
'npm:devexpress-gantt@4.1.67/package.json',
'npm:@aspnet/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"@angular/core": {
"version": "21.0.7"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>
using System.Collections.Generic;
using DevExtreme.MVC.Demos.Models.SignalR;
using Microsoft.AspNet.SignalR;
namespace DevExtreme.MVC.Demos.Hubs {
public class LiveUpdateSignalRHub : Hub {
private readonly StockTicker _stockTicker;
public LiveUpdateSignalRHub() {
_stockTicker = StockTicker.Instance;
}
public IEnumerable<Stock> GetAllStocks() {
return _stockTicker.GetAllStocks();
}
}
}
using System;
using System.Collections.Generic;
using System.Threading;
using DevExtreme.MVC.Demos.Hubs;
using Microsoft.AspNet.SignalR;
using Microsoft.AspNet.SignalR.Hubs;
using DevExpress.Data.Utils;
namespace DevExtreme.MVC.Demos.Models.SignalR {
public class StockTicker {
public readonly static StockTicker Instance = new StockTicker(GlobalHost.ConnectionManager.GetHubContext<LiveUpdateSignalRHub>().Clients);
private readonly IEnumerable<Stock> _stocks;
private IHubConnectionContext<dynamic> Clients { get; set; }
private readonly TimeSpan _updateInterval = TimeSpan.FromMilliseconds(500);
private readonly NonCryptographicRandom _updateOrNotRandom = NonCryptographicRandom.System;
private readonly Timer _timer;
private readonly object _updateStockPricesLock = new object();
static readonly NonCryptographicRandom random = NonCryptographicRandom.System;
private StockTicker(IHubConnectionContext<dynamic> clients) {
Clients = clients;
_stocks = GenerateStocks();
_timer = new Timer(UpdateStockPrices, null, _updateInterval, _updateInterval);
}
public IEnumerable<Stock> GetAllStocks() {
return _stocks;
}
static IEnumerable<Stock> GenerateStocks() {
return new[] {
new Stock(37.95M) { Symbol = "MSFT", DayOpen=36.5M, LastUpdate = DateTime.Now },
new Stock(24.85M) { Symbol = "INTC", DayOpen=24.9M, LastUpdate = DateTime.Now },
new Stock(22.99M){ Symbol = "CSCO", DayOpen=22.7M, LastUpdate = DateTime.Now },
new Stock(30.71M){ Symbol = "SIRI", DayOpen=30.7M, LastUpdate = DateTime.Now },
new Stock(58.73M){ Symbol = "AAPL", DayOpen=54.9M, LastUpdate = DateTime.Now },
new Stock(110M){ Symbol = "HOKU", DayOpen=121.2M, LastUpdate = DateTime.Now },
new Stock(38.11M){ Symbol = "ORCL", DayOpen=37.9M, LastUpdate = DateTime.Now },
new Stock(17.61M) { Symbol = "AMAT", DayOpen=17.5M, LastUpdate = DateTime.Now },
new Stock(40.80M){ Symbol = "YHOO", DayOpen=39.9M, LastUpdate = DateTime.Now },
new Stock(31.85M){ Symbol = "LVLT", DayOpen=32.9M, LastUpdate = DateTime.Now },
new Stock(20.63M){ Symbol = "DELL", DayOpen=17.9M, LastUpdate = DateTime.Now },
new Stock(63.70M) { Symbol = "GOOG", DayOpen=55.9M, LastUpdate = DateTime.Now }
};
}
private void UpdateStockPrices(object state) {
lock(_updateStockPricesLock) {
foreach(var stock in _stocks) {
if(TryUpdateStockPrice(stock)) {
BroadcastStockPrice(stock);
}
}
}
}
private bool TryUpdateStockPrice(Stock stock) {
var r = _updateOrNotRandom.NextDouble();
if(r > .1) {
return false;
}
stock.Update();
return true;
}
private void BroadcastStockPrice(Stock stock) {
Clients.All.updateStockPrice(stock);
}
}
}
using System;
using DevExpress.Data.Utils;
namespace DevExtreme.MVC.Demos.Models.SignalR {
public class Stock {
readonly decimal _initPrice;
public Stock(decimal price) {
Price = price;
DayMax = price;
DayMin = price;
_initPrice = Price;
}
public string Symbol { get; set; }
public decimal Price { get; set; }
public decimal DayMax { get; set; }
public decimal DayMin { get; set; }
public decimal DayOpen { get; set; }
public DateTime LastUpdate { get; set; }
public decimal Change {
get {
return Price - DayOpen;
}
}
public double PercentChange {
get {
return (double)Math.Round(Change * 100 / DayOpen, 2);
}
}
public void Update() {
var isNewDay = LastUpdate.Day != DateTime.Now.Day;
var change = GenerateChange();
var newPrice = _initPrice + _initPrice * change;
Price = newPrice;
LastUpdate = DateTime.Now;
if(Price > DayMax || isNewDay)
DayMax = Price;
if(Price < DayMin || isNewDay)
DayMin = Price;
}
static NonCryptographicRandom random = NonCryptographicRandom.System;
decimal GenerateChange() {
return (decimal)random.Next(-200, 200) / 10000;
}
}
}
For more information about integration with push services, refer to the following help topic: Integration with Push Services.
Data used in this demo is for demonstration purposes only.

Feel free to share demo-related thoughts here.
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Thank you for the feedback!
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Backend API
x
import React, { useEffect, useState } from 'react';
import DataGrid, {
Column,
} from 'devextreme-react/data-grid';
import CustomStore from 'devextreme/data/custom_store';
import { HubConnectionBuilder, HttpTransportType } from '@aspnet/signalr';
import PriceCell from './PriceCell.tsx';
import ChangeCell from './ChangeCell.tsx';
const App = () => {
const [connectionStarted, setConnectionStarted] = useState(false);
const [dataSource, setDataSource] = useState(null);
useEffect(() => {
const hubConnection = new HubConnectionBuilder()
.withUrl('https://js.devexpress.com/Demos/NetCore/liveUpdateSignalRHub', {
skipNegotiation: true,
transport: HttpTransportType.WebSockets,
})
.build();
const store = new CustomStore({
load: () => hubConnection.invoke('getAllStocks'),
key: 'symbol',
});
hubConnection
.start()
.then(() => {
hubConnection.on('updateStockPrice', (data) => {
store.push([{ type: 'update', key: data.symbol, data }]);
});
setConnectionStarted(true);
setDataSource(store);
});
}, []);
return (
<div>
{connectionStarted && (
<DataGrid
id="gridContainer"
dataSource={dataSource}
showBorders={true}
repaintChangesOnly={true}
highlightChanges={true}
>
<Column dataField="lastUpdate" dataType="date" width={115} format="longTime" />
<Column dataField="symbol" />
<Column dataField="price" dataType="number" format="#0.####" cellRender={PriceCell} />
<Column dataField="change" dataType="number" width={140} format="#0.####" cellRender={ChangeCell} />
<Column dataField="dayOpen" dataType="number" format="#0.####" />
<Column dataField="dayMin" dataType="number" format="#0.####" />
<Column dataField="dayMax" dataType="number" format="#0.####" />
</DataGrid>
)}
</div>
);
};
export default App;
xxxxxxxxxx
import React, { useEffect, useState } from 'react';
import DataGrid, { Column } from 'devextreme-react/data-grid';
import CustomStore from 'devextreme/data/custom_store';
import { HubConnectionBuilder, HttpTransportType } from '@aspnet/signalr';
import PriceCell from './PriceCell.js';
import ChangeCell from './ChangeCell.js';
const App = () => {
const [connectionStarted, setConnectionStarted] = useState(false);
const [dataSource, setDataSource] = useState(null);
useEffect(() => {
const hubConnection = new HubConnectionBuilder()
.withUrl('https://js.devexpress.com/Demos/NetCore/liveUpdateSignalRHub', {
skipNegotiation: true,
transport: HttpTransportType.WebSockets,
})
.build();
const store = new CustomStore({
load: () => hubConnection.invoke('getAllStocks'),
key: 'symbol',
});
hubConnection.start().then(() => {
hubConnection.on('updateStockPrice', (data) => {
store.push([{ type: 'update', key: data.symbol, data }]);
});
setConnectionStarted(true);
setDataSource(store);
});
}, []);
return (
<div>
{connectionStarted && (
<DataGrid
id="gridContainer"
dataSource={dataSource}
showBorders={true}
repaintChangesOnly={true}
highlightChanges={true}
>
<Column
dataField="lastUpdate"
dataType="date"
width={115}
format="longTime"
/>
<Column dataField="symbol" />
<Column
dataField="price"
dataType="number"
format="#0.####"
cellRender={PriceCell}
/>
<Column
dataField="change"
dataType="number"
width={140}
format="#0.####"
cellRender={ChangeCell}
/>
<Column
dataField="dayOpen"
dataType="number"
format="#0.####"
/>
<Column
dataField="dayMin"
dataType="number"
format="#0.####"
/>
<Column
dataField="dayMax"
dataType="number"
format="#0.####"
/>
</DataGrid>
)}
</div>
);
};
export default App;
xxxxxxxxxx
import { DataGridTypes } from 'devextreme-react/data-grid';
import React from 'react';
const ChangeCell = (cell: DataGridTypes.ColumnCellTemplateData) => (
<div className={cell.data.change > 0 ? 'inc' : 'dec' }>
<span className="current-value">{cell.text}</span>
<span className="arrow"></span>
<span className="diff">{cell.data.percentChange.toFixed(2)}%</span>
</div>
);
export default ChangeCell;
xxxxxxxxxx
import { DataGridTypes } from 'devextreme-react/data-grid';
import React from 'react';
const PriceCell = (cell: DataGridTypes.ColumnCellTemplateData) => (
<div className={cell.data.change > 0 ? 'inc' : 'dec' }>
<span>{cell.text}</span>
</div>
);
export default PriceCell;
xxxxxxxxxx
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
xxxxxxxxxx
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
'bundles:': 'bundles/',
'externals:': 'bundles/externals/',
},
defaultExtension: 'js',
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'@aspnet/signalr': 'npm:@aspnet/signalr@1.0.27/dist/cjs',
'tslib': 'npm:tslib/tslib.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@24.2.6/cjs',
'devextreme-react': 'npm:devextreme-react@24.2.6/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.1/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.15/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.60/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.12',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'@aspnet/signalr': {
main: 'index.js',
defaultExtension: 'js',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.12/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);
xxxxxxxxxx
import React from 'react';
const ChangeCell = (cell) => (
<div className={cell.data.change > 0 ? 'inc' : 'dec'}>
<span className="current-value">{cell.text}</span>
<span className="arrow"></span>
<span className="diff">{cell.data.percentChange.toFixed(2)}%</span>
</div>
);
export default ChangeCell;
xxxxxxxxxx
import React from 'react';
const PriceCell = (cell) => (
<div className={cell.data.change > 0 ? 'inc' : 'dec'}>
<span>{cell.text}</span>
</div>
);
export default PriceCell;
xxxxxxxxxx
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
xxxxxxxxxx
<html lang="en">
<head></head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
xxxxxxxxxx
#gridContainer span.current-value {
display: inline-block;
margin-right: 5px;
}
#gridContainer span.diff {
width: 50px;
display: inline-block;
}
#gridContainer .inc {
color: #2ab71b;
}
#gridContainer .dec {
color: #f00;
}
#gridContainer .inc .arrow,
#gridContainer .dec .arrow {
display: inline-block;
height: 10px;
width: 10px;
background-repeat: no-repeat;
background-size: 10px 10px;
}
#gridContainer .inc .arrow {
background-image: url('data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAABQAAAAUCAYAAACNiR0NAAAABGdBTUEAAK/INwWK6QAAABl0RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAADKSURBVHjaYtTaLs1ABEiG0nPRJa56PEHhsxBhmCUQT4OyrwHxcXyKmQgYJgHE64CYDYrXQcXIMhCbAcgWkGzgNKh38QUB0QamIUUErkhKI9ZAGyCeTERkTYaqxWsgKA2txhdG6GGsvUNGGpeBRMUiGhCFGsqGzUBQQJsxkA5AemaiG5hDIBIIgQSgK0FmMDACs549kN5FZLjhA7+A2A2U9YSAOBeLAk4gnoBDczoOcSFGPIUDPxB/wCHHiKtwYGKgMhg1cBAaCBBgAJTUIL3ToPZfAAAAAElFTkSuQmCC');
}
#gridContainer .dec .arrow {
background-image: url('data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAABQAAAAUCAYAAACNiR0NAAAABGdBTUEAAK/INwWK6QAAABl0RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAADJSURBVHjaYvzPgBfgkhYA4o8QFahKmBioDEYNHIQGsgBxIBCLkqgvAYi/g1mMjMjir0EJzR6If/6HpChKMMgMe3DKBeIcKhiY8x/MYoDj+RQYNgdkGLqBbEB8kgzDToL1YjEQhKWB+BUJhj0H64Eahs1AELYhMpJ+gtUiGYbLQBBOI8LANLBaIg1kAAc0vkiAqSPBQFAkHcNi2DGoHMkGgrAENOCRI0ECRQ2JBoKwJTQCfkLZDPgMZPxPXN5NhtJzMSsJVBMAAgwAyWSY2svfmrwAAAAASUVORK5CYII=');
}
xxxxxxxxxx
using System.Collections.Generic;
using DevExtreme.MVC.Demos.Models.SignalR;
using Microsoft.AspNet.SignalR;
namespace DevExtreme.MVC.Demos.Hubs {
public class LiveUpdateSignalRHub : Hub {
private readonly StockTicker _stockTicker;
public LiveUpdateSignalRHub() {
_stockTicker = StockTicker.Instance;
}
public IEnumerable<Stock> GetAllStocks() {
return _stockTicker.GetAllStocks();
}
}
}
xxxxxxxxxx
using System;
using System.Collections.Generic;
using System.Threading;
using DevExtreme.MVC.Demos.Hubs;
using Microsoft.AspNet.SignalR;
using Microsoft.AspNet.SignalR.Hubs;
using DevExpress.Data.Utils;
namespace DevExtreme.MVC.Demos.Models.SignalR {
public class StockTicker {
public readonly static StockTicker Instance = new StockTicker(GlobalHost.ConnectionManager.GetHubContext<LiveUpdateSignalRHub>().Clients);
private readonly IEnumerable<Stock> _stocks;
private IHubConnectionContext<dynamic> Clients { get; set; }
private readonly TimeSpan _updateInterval = TimeSpan.FromMilliseconds(500);
private readonly NonCryptographicRandom _updateOrNotRandom = NonCryptographicRandom.System;
private readonly Timer _timer;
private readonly object _updateStockPricesLock = new object();
static readonly NonCryptographicRandom random = NonCryptographicRandom.System;
private StockTicker(IHubConnectionContext<dynamic> clients) {
Clients = clients;
_stocks = GenerateStocks();
_timer = new Timer(UpdateStockPrices, null, _updateInterval, _updateInterval);
}
public IEnumerable<Stock> GetAllStocks() {
return _stocks;
}
static IEnumerable<Stock> GenerateStocks() {
return new[] {
new Stock(37.95M) { Symbol = "MSFT", DayOpen=36.5M, LastUpdate = DateTime.Now },
new Stock(24.85M) { Symbol = "INTC", DayOpen=24.9M, LastUpdate = DateTime.Now },
new Stock(22.99M){ Symbol = "CSCO", DayOpen=22.7M, LastUpdate = DateTime.Now },
new Stock(30.71M){ Symbol = "SIRI", DayOpen=30.7M, LastUpdate = DateTime.Now },
new Stock(58.73M){ Symbol = "AAPL", DayOpen=54.9M, LastUpdate = DateTime.Now },
new Stock(110M){ Symbol = "HOKU", DayOpen=121.2M, LastUpdate = DateTime.Now },
new Stock(38.11M){ Symbol = "ORCL", DayOpen=37.9M, LastUpdate = DateTime.Now },
new Stock(17.61M) { Symbol = "AMAT", DayOpen=17.5M, LastUpdate = DateTime.Now },
new Stock(40.80M){ Symbol = "YHOO", DayOpen=39.9M, LastUpdate = DateTime.Now },
new Stock(31.85M){ Symbol = "LVLT", DayOpen=32.9M, LastUpdate = DateTime.Now },
new Stock(20.63M){ Symbol = "DELL", DayOpen=17.9M, LastUpdate = DateTime.Now },
new Stock(63.70M) { Symbol = "GOOG", DayOpen=55.9M, LastUpdate = DateTime.Now }
};
}
private void UpdateStockPrices(object state) {
lock(_updateStockPricesLock) {
foreach(var stock in _stocks) {
if(TryUpdateStockPrice(stock)) {
BroadcastStockPrice(stock);
}
}
}
}
private bool TryUpdateStockPrice(Stock stock) {
var r = _updateOrNotRandom.NextDouble();
if(r > .1) {
return false;
}
stock.Update();
return true;
}
private void BroadcastStockPrice(Stock stock) {
Clients.All.updateStockPrice(stock);
}
}
}
xxxxxxxxxx
using System;
using DevExpress.Data.Utils;
namespace DevExtreme.MVC.Demos.Models.SignalR {
public class Stock {
readonly decimal _initPrice;
public Stock(decimal price) {
Price = price;
DayMax = price;
DayMin = price;
_initPrice = Price;
}
public string Symbol { get; set; }
public decimal Price { get; set; }
public decimal DayMax { get; set; }
public decimal DayMin { get; set; }
public decimal DayOpen { get; set; }
public DateTime LastUpdate { get; set; }
public decimal Change {
get {
return Price - DayOpen;
}
}
public double PercentChange {
get {
return (double)Math.Round(Change * 100 / DayOpen, 2);
}
}
public void Update() {
var isNewDay = LastUpdate.Day != DateTime.Now.Day;
var change = GenerateChange();
var newPrice = _initPrice + _initPrice * change;
Price = newPrice;
LastUpdate = DateTime.Now;
if(Price > DayMax || isNewDay)
DayMax = Price;
if(Price < DayMin || isNewDay)
DayMin = Price;
}
static NonCryptographicRandom random = NonCryptographicRandom.System;
decimal GenerateChange() {
return (decimal)random.Next(-200, 200) / 10000;
}
}
}
For more information about integration with push services, refer to the following help topic: Integration with Push Services.
NOTE
Data used in this demo is for demonstration purposes only.

Feel free to share demo-related thoughts here.
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Thank you for the feedback!
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Backend API
<template>
<div v-if="connectionStarted">
<DxDataGrid
id="gridContainer"
:data-source="dataSource"
:repaint-changes-only="true"
:highlight-changes="true"
:show-borders="true"
>
<DxColumn
:width="115"
data-field="lastUpdate"
data-type="date"
format="longTime"
/>
<DxColumn
data-field="symbol"
/>
<DxColumn
data-field="price"
data-type="number"
format="#0.####"
cell-template="priceCellTemplate"
/>
<DxColumn
:width="140"
data-field="change"
data-type="number"
format="#0.####"
cell-template="changeCellTemplate"
/>
<DxColumn
data-field="dayOpen"
data-type="number"
format="#0.####"
/>
<DxColumn
data-field="dayMin"
data-type="number"
format="#0.####"
/>
<DxColumn
data-field="dayMax"
data-type="number"
format="#0.####"
/>
<template #priceCellTemplate="{ data: cellData }">
<PriceCell :cell-data="cellData"/>
</template>
<template #changeCellTemplate="{ data: cellData }">
<ChangeCell :cell-data="cellData"/>
</template>
</DxDataGrid>
</div>
</template>
<script setup lang="ts">
import { onMounted, ref } from 'vue';
import {
DxDataGrid,
DxColumn,
} from 'devextreme-vue/data-grid';
import { CustomStore } from 'devextreme-vue/common/data';
import { HubConnectionBuilder, HttpTransportType } from '@aspnet/signalr';
import PriceCell from './PriceCell.vue';
import ChangeCell from './ChangeCell.vue';
const connectionStarted = ref(false);
const dataSource = ref<CustomStore | null>(null);
onMounted(() => {
const hubConnection = new HubConnectionBuilder()
.withUrl('https://js.devexpress.com/Demos/NetCore/liveUpdateSignalRHub', {
skipNegotiation: true,
transport: HttpTransportType.WebSockets,
})
.build();
const store = new CustomStore({
load: () => hubConnection.invoke('getAllStocks'),
key: 'symbol',
});
hubConnection
.start()
.then(() => {
hubConnection.on('updateStockPrice', (data) => {
store.push([{ type: 'update', key: data.symbol, data }]);
});
dataSource.value = store;
connectionStarted.value = true;
});
});
</script>
<style>
#gridContainer span.current-value {
display: inline-block;
margin-right: 5px;
}
#gridContainer span.diff {
width: 50px;
display: inline-block;
}
#gridContainer .inc {
color: #2ab71b;
}
#gridContainer .dec {
color: #f00;
}
#gridContainer .inc .arrow,
#gridContainer .dec .arrow {
display: inline-block;
height: 10px;
width: 10px;
background-repeat: no-repeat;
background-size: 10px 10px;
}
#gridContainer .inc .arrow {
background-image: url('data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAABQAAAAUCAYAAACNiR0NAAAABGdBTUEAAK/INwWK6QAAABl0RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAADKSURBVHjaYtTaLs1ABEiG0nPRJa56PEHhsxBhmCUQT4OyrwHxcXyKmQgYJgHE64CYDYrXQcXIMhCbAcgWkGzgNKh38QUB0QamIUUErkhKI9ZAGyCeTERkTYaqxWsgKA2txhdG6GGsvUNGGpeBRMUiGhCFGsqGzUBQQJsxkA5AemaiG5hDIBIIgQSgK0FmMDACs549kN5FZLjhA7+A2A2U9YSAOBeLAk4gnoBDczoOcSFGPIUDPxB/wCHHiKtwYGKgMhg1cBAaCBBgAJTUIL3ToPZfAAAAAElFTkSuQmCC');
}
#gridContainer .dec .arrow {
background-image: url('data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAABQAAAAUCAYAAACNiR0NAAAABGdBTUEAAK/INwWK6QAAABl0RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAADJSURBVHjaYvzPgBfgkhYA4o8QFahKmBioDEYNHIQGsgBxIBCLkqgvAYi/g1mMjMjir0EJzR6If/6HpChKMMgMe3DKBeIcKhiY8x/MYoDj+RQYNgdkGLqBbEB8kgzDToL1YjEQhKWB+BUJhj0H64Eahs1AELYhMpJ+gtUiGYbLQBBOI8LANLBaIg1kAAc0vkiAqSPBQFAkHcNi2DGoHMkGgrAENOCRI0ECRQ2JBoKwJTQCfkLZDPgMZPxPXN5NhtJzMSsJVBMAAgwAyWSY2svfmrwAAAAASUVORK5CYII=');
}
</style>
<template>
<div :class="{ inc: cellData.data.change > 0, dec: cellData.data.change < 0 }">
<span class="current-value">{{ cellData.text }}</span>
<span class="arrow"/>
<span class="diff">{{ cellData.data.percentChange.toFixed(2) }}%</span>
</div>
</template>
<script setup lang="ts">
import { type DxDataGridTypes } from 'devextreme-vue/data-grid';
defineProps<{
cellData: DxDataGridTypes.ColumnCellTemplateData
}>();
</script>
<template>
<div :class="{ inc: cellData.data.change > 0, dec: cellData.data.change < 0 }">
<span>{{ cellData.text }}</span>
</div>
</template>
<script setup lang="ts">
import { type DxDataGridTypes } from 'devextreme-vue/data-grid';
defineProps<{
cellData: DxDataGridTypes.ColumnCellTemplateData
}>();
</script>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
},
map: {
'vue': 'npm:vue@3.4.27/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'@aspnet/signalr': 'npm:@aspnet/signalr@1.0.27/dist/cjs',
'tslib': 'npm:tslib/tslib.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@25.1.3/cjs',
'devextreme-vue': 'npm:devextreme-vue@25.1.3/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.3/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.19/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.62/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'@aspnet/signalr': {
main: 'index.js',
defaultExtension: 'js',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
System.config(window.config);
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.3/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/typescript@5.4.5/lib/typescript.js"></script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>
using System.Collections.Generic;
using DevExtreme.MVC.Demos.Models.SignalR;
using Microsoft.AspNet.SignalR;
namespace DevExtreme.MVC.Demos.Hubs {
public class LiveUpdateSignalRHub : Hub {
private readonly StockTicker _stockTicker;
public LiveUpdateSignalRHub() {
_stockTicker = StockTicker.Instance;
}
public IEnumerable<Stock> GetAllStocks() {
return _stockTicker.GetAllStocks();
}
}
}
using System;
using System.Collections.Generic;
using System.Threading;
using DevExtreme.MVC.Demos.Hubs;
using Microsoft.AspNet.SignalR;
using Microsoft.AspNet.SignalR.Hubs;
using DevExpress.Data.Utils;
namespace DevExtreme.MVC.Demos.Models.SignalR {
public class StockTicker {
public readonly static StockTicker Instance = new StockTicker(GlobalHost.ConnectionManager.GetHubContext<LiveUpdateSignalRHub>().Clients);
private readonly IEnumerable<Stock> _stocks;
private IHubConnectionContext<dynamic> Clients { get; set; }
private readonly TimeSpan _updateInterval = TimeSpan.FromMilliseconds(500);
private readonly NonCryptographicRandom _updateOrNotRandom = NonCryptographicRandom.System;
private readonly Timer _timer;
private readonly object _updateStockPricesLock = new object();
static readonly NonCryptographicRandom random = NonCryptographicRandom.System;
private StockTicker(IHubConnectionContext<dynamic> clients) {
Clients = clients;
_stocks = GenerateStocks();
_timer = new Timer(UpdateStockPrices, null, _updateInterval, _updateInterval);
}
public IEnumerable<Stock> GetAllStocks() {
return _stocks;
}
static IEnumerable<Stock> GenerateStocks() {
return new[] {
new Stock(37.95M) { Symbol = "MSFT", DayOpen=36.5M, LastUpdate = DateTime.Now },
new Stock(24.85M) { Symbol = "INTC", DayOpen=24.9M, LastUpdate = DateTime.Now },
new Stock(22.99M){ Symbol = "CSCO", DayOpen=22.7M, LastUpdate = DateTime.Now },
new Stock(30.71M){ Symbol = "SIRI", DayOpen=30.7M, LastUpdate = DateTime.Now },
new Stock(58.73M){ Symbol = "AAPL", DayOpen=54.9M, LastUpdate = DateTime.Now },
new Stock(110M){ Symbol = "HOKU", DayOpen=121.2M, LastUpdate = DateTime.Now },
new Stock(38.11M){ Symbol = "ORCL", DayOpen=37.9M, LastUpdate = DateTime.Now },
new Stock(17.61M) { Symbol = "AMAT", DayOpen=17.5M, LastUpdate = DateTime.Now },
new Stock(40.80M){ Symbol = "YHOO", DayOpen=39.9M, LastUpdate = DateTime.Now },
new Stock(31.85M){ Symbol = "LVLT", DayOpen=32.9M, LastUpdate = DateTime.Now },
new Stock(20.63M){ Symbol = "DELL", DayOpen=17.9M, LastUpdate = DateTime.Now },
new Stock(63.70M) { Symbol = "GOOG", DayOpen=55.9M, LastUpdate = DateTime.Now }
};
}
private void UpdateStockPrices(object state) {
lock(_updateStockPricesLock) {
foreach(var stock in _stocks) {
if(TryUpdateStockPrice(stock)) {
BroadcastStockPrice(stock);
}
}
}
}
private bool TryUpdateStockPrice(Stock stock) {
var r = _updateOrNotRandom.NextDouble();
if(r > .1) {
return false;
}
stock.Update();
return true;
}
private void BroadcastStockPrice(Stock stock) {
Clients.All.updateStockPrice(stock);
}
}
}
using System;
using DevExpress.Data.Utils;
namespace DevExtreme.MVC.Demos.Models.SignalR {
public class Stock {
readonly decimal _initPrice;
public Stock(decimal price) {
Price = price;
DayMax = price;
DayMin = price;
_initPrice = Price;
}
public string Symbol { get; set; }
public decimal Price { get; set; }
public decimal DayMax { get; set; }
public decimal DayMin { get; set; }
public decimal DayOpen { get; set; }
public DateTime LastUpdate { get; set; }
public decimal Change {
get {
return Price - DayOpen;
}
}
public double PercentChange {
get {
return (double)Math.Round(Change * 100 / DayOpen, 2);
}
}
public void Update() {
var isNewDay = LastUpdate.Day != DateTime.Now.Day;
var change = GenerateChange();
var newPrice = _initPrice + _initPrice * change;
Price = newPrice;
LastUpdate = DateTime.Now;
if(Price > DayMax || isNewDay)
DayMax = Price;
if(Price < DayMin || isNewDay)
DayMin = Price;
}
static NonCryptographicRandom random = NonCryptographicRandom.System;
decimal GenerateChange() {
return (decimal)random.Next(-200, 200) / 10000;
}
}
}
For more information about integration with push services, refer to the following help topic: Integration with Push Services.
NOTE
Data used in this demo is for demonstration purposes only.